require "stuka/commands/command"
require "stuka/commands/subcommands/create/create_process_file"

module Stuka

  class ProcessCommand < Command
    
    argument :name, :desc => "Name of the process"
    argument :blocks, type: :array, default: [], :desc => "Name of blocks"

    def execute
      Stuka::CreateProcessFile.new.create(name, blocks)
    end

    def self.description
      "generates a process stub"
    end

    def self.usage
      "process NAME *BLOCK_NAMES"
    end

  end

end