module Stuka

  require "stuka/commands/command"
  Dir["#{File.dirname(__FILE__)}/../subcommands/setup/*.rb"].each { |file| require_relative file }

  class SetupCommand < Command

    def execute
      Stuka::SetupConfig.new.setup
      Stuka::SetupDirectories.new.setup
      Stuka::SetupGemfile.new.setup
      Stuka::SetupRakefile.new.setup
      Stuka::SetupTasks.new.setup
    end

    def self.description
      "generates stuka DSL source folders and a Gemfile"
    end

  end
end