require 'thor'
Dir["#{File.dirname(__FILE__)}/public_commands/*.rb"].each { |file| require_relative file }

module Stuka

  class StukaCli < Thor

    # Retrieve all classes from the Stuka module that end with Command except Stuka::Command abstract class
    # Register all those classes so they are available in the terminal as commands using
    # register(class_name, subcommand_alias, usage_list_string, description_string)
    commands = Stuka.constants.select { |c| c.match(/\w+Command/) && Stuka.const_get(c).is_a?(Class) }
    commands.each do |command|
      commandClass = Stuka.const_get(command)
      register(commandClass, commandClass.alias, commandClass.usage, commandClass.description)
    end
  end
end