require "stuka/commands/command"
Dir["#{File.dirname(__FILE__)}/../setup/*.rb"].each { |file| require_relative file }


module Stuka

  class CreateProject < Command

    def create(name)
      project_dir_exists = File.directory?("#{Dir.pwd}/#{name}")

      if project_dir_exists
        say("Directory already exists, choose another name.")
        return
      end

      Dir.mkdir name
      setup(name)
    end

    def setup(name)
      Dir.chdir(name) do
        SetupConfig.new.setup
        SetupDirectories.new.setup
        SetupGemfile.new.setup
        SetupRakefile.new.setup
        SetupTasks.new.setup
      end

    end

  end

end