require "stuka/commands/command"
require 'stuka/config/stuka_paths'
require 'fileutils'

module Stuka

  class SetupDirectories < Command

    def setup
      processes_dir_exists = File.directory?("#{Dir.pwd}/#{StukaPaths.relative_processes_source_path}")

      if processes_dir_exists
        say("\tStuka dsl source directories are already setup")
        return
      end

      FileUtils.mkdir_p "process_definition"
      template('templates/samples/process_file.tt', "process_definition/process_file.rb")
      say("\tSource directories setup")
   
    end

  end

end