module Stuka

  module TemplateConfig

    RescuableExceptions = [LoadError, NameError]

    def self.action_module_namespaces

      config_item = get_config_item("ActionModuleNamespaces")

      if config_item
        return config_item
      else
        ACTION_MODULE_NAMESPACES
      end

    end

    def self.add_require_statements

      add_requires = get_config_item("AddRequires")

      unless add_requires.nil?
        return add_requires
      else
        ADD_REQUIRE_STATEMENTS
      end
    
    end

    def self.process_module_namespaces

      config_item = get_config_item("ProcessModuleNamespaces")

      if config_item
        return config_item
      else
        PROCESS_MODULE_NAMESPACES
      end
    
    end

    def self.get_config_item(name)
      begin
        require_relative "#{Dir.pwd}/stuka_config"
        return StukaConfig.const_get(name)
      rescue *RescuableExceptions
        return false
      end
    end

    # defaults
    ACTION_MODULE_NAMESPACES = ["Actions"]
    PROCESS_MODULE_NAMESPACES = ["Processes"]
    ADD_REQUIRE_STATEMENTS = true

  end

end