require 'stuka/external/unknown_action'
require 'stuka/config/stuka_paths'
require 'stuka/monkeypatch/string_patch'
require 'stuka/config/template_config'

module Stuka::External

  class ActionFinder

    def find_action action, process
      namespace, name = action.split "::"
      class_namespace = namespace.camelcase_notation
      class_name = name.camelcase_notation
      action_modules = Stuka::TemplateConfig.action_module_namespaces
      begin
        clazz = Object.const_get("#{action_modules.join("::")}::#{class_namespace}::#{class_name}")
      rescue NameError
        file_path = "#{Stuka::StukaPaths.actions_source_path}/#{namespace}/#{name}"
        raise Stuka::External::UnknownAction.new(action) unless File.file?("#{file_path}.rb")
        require_relative file_path
        clazz = Object.const_get("#{action_modules.join("::")}::#{class_namespace}::#{class_name}")
      end
      clazz.new(process)
    end

  end


end