module Stuka::External

  class Dispatcher

    attr_reader :callbacks

    def initialize
      @callbacks = {}
    end

    def can_end_with?(name)
      @callbacks.has_key?(name)
    end

    def method_missing(name, *args, &block)
      callbacks[name] = block
    end

    def call(name, args)
      name = name.to_sym
      cb = callbacks[name]
      cb ? cb.call(args) : false
    end

  end

end