module Stuka::External::ProcessStates

  class StartedState

    def handle_transition(context, transition)
      context.instance_eval do
        new_block = next_block(transition)
        if new_block.start_with?("process::")
          process_message = new_block.split("::")[1]
          send(process_message.to_sym, action_params)
        else
          set_current_block(new_block)
          action_name = blocks[new_block][:action]
          action_instance = action_finder.find_action(action_name, context)
          action_instance.run(action_params)
        end
      end
    end

  end

end