require_relative "domain"

module Stuka

  class Action < Domain

    # needed durring generation
    attr_accessor :implementation, :definition_file

    # must not be nil
    ATTRS = ["name", "description", "namespace", "endings"]

    # must not be empty
    REQUIRED_ATTRS = ["name", "namespace", "endings"]

    def initialize(name, namespace = nil, description = nil, endings = [])
      super()
      raise "'process' namespace is reserved" if namespace == "process"
      @name = name
      @namespace = namespace
      @description = description
      @endings = endings.map(&:to_sym)
      @implementation = ""
      @definition_file = ""
    end

    # redefined
    def namespace(namespace = nil)
      raise "'process' namespace is reserved" if namespace == "process"
      if namespace
        @namespace = namespace
      else
        @namespace
      end
    end

    def endings(endings_array = nil)
      if endings_array
        @endings = endings_array.map(&:to_sym)
      else
        @endings
      end
    end

    def full_name
      "#{namespace}::#{name}"
    end

  end

end