require 'stuka/internal/domain/action'
require_relative 'domain_builder'

module Stuka

  class ActionDomainBuilder < DomainBuilder

    attr_accessor :instances

    def initialize
      super()
      @instances = []
    end

    def action(name, &block)
      namespace, action_name = [nil, name]
      if name.include?("::")
        namespace, action_name = name.split("::")
      end
      act = Action.new(action_name, namespace)
      act.instance_eval(&block)
      @instances << act
      act
    end

  end

end