module Stuka

  class DomainBuilder

    attr_reader :current_file_path

    DOMAIN_OBJECTS = ["process", "action"]

    def initialize
      @current_file_path = ""
    end

    DOMAIN_OBJECTS.each do |object_name|
      define_method object_name.to_sym do |*arg|
        #empty process and action method so it does not raise method not found
      end
    end

    def domain_files
      Dir["#{Stuka::StukaPaths.processes_definition_path}/**/*.rb"]
    end

    def build_domain
      domain_files.each do |path|
        @current_file_path = path
        instance_eval(File.read(path), path, __LINE__)
      end
      self
    end

  end

end