require 'stuka/internal/domain/process'
require_relative 'domain_builder'

module Stuka

  class ProcessDomainBuilder < DomainBuilder

    attr_accessor :process_instances, :action_instances

    def initialize
      super()
      @process_instances = []
      @action_instances = []
    end

    def process(name, &block)
      proc = Process.new(name)
      proc.definition_file = current_file_path
      proc.instance_eval(&block)
      @process_instances << proc
      proc.actions.each do |acc|
        next if @action_instances.map(&:name).include? acc.name
        @action_instances << acc
      end
      proc
    end

  end

end